#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use htbuild;
use pseek;
use fmspm;


&get_setup;
fmspm::check_spamb("rgs_cp.cgi", "header", "$data_dir");
$q = CGI->new;

$default_permissions = 0777;

################# 


$cpuserid = pseek::accesscheck($q->param('rgs_user'), $q->param('rgs_pass'));

$gsettings = new_gsettings tseek;  

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&display_main;}







sub display_main
{


$cp_template = pseek::get_file_contents("$data_dir/rgs_cpmain.html");


### GET LINKS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

#$sql = "SELECT * FROM links WHERE userid = '$cpuserid'";

		$sql = "SELECT A.*, B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.level
						FROM links AS A, dirs AS B
						WHERE
						(A.cid = B.cid) AND 
						(A.userid = '$cpuserid')
					  ORDER BY A.premium DESC, A.urldate ASC";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

#######
$standlinks = pseek::get_file_contents("$data_dir/rgs_acclinks.html");
$premlinks = pseek::get_file_contents("$data_dir/rgs_acclinksp.html");

$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;
$start_count = $knr + 27;

$key_upload_data = pseek::get_file_contents("$data_dir/keysupl.dat");
@upl_items = split (/:-o_:/, $key_upload_data); 


$rgtext = pseek::get_file_contents("$data_dir/regusers.txt"); 
@regtext = split (/\n/, $rgtext);

####### $row[21]

$todaytime = time();

while ( @row = $sth->fetchrow() )
	{
	
	if ($row[21] < 1) { $row[21] = "9999999999999999999999"; }

	
	
	if (($row[13] > 0) and ($row[21] > $todaytime))  ### IF PREMIUM LINK
		{
		
		$tmpl_links = $premlinks;
		
		if (($row[21] > 0) and ($row[21] != "9999999999999999999999"))
			{
			$prem_exp = $row[21];
			$prem_exp = pseek::decode_date($prem_exp);
			}
			else
			{
			$rgtext = pseek::get_file_contents("$data_dir/regusers.txt");
			@regtext = split (/\n/, $rgtext);
			$prem_exp = $regtext[0];
			}
		
		$tmpl_links =~ s/!!premium_expiry!!/$prem_exp/gi;
		}
		else
		{
		$tmpl_links = $standlinks;
		}

	###
	
	$title_with_link = $row[2];
	$description = $row[3];
	$itemurl = $row[5];
	$date = $row[17];
	$votes = $row[11];
	$rating = $row[10];
	$hits = $row[12];
	$url = $row[5];
	$listing_keywords = $row[4];
	
	
	$tmpl_links =~ s/!!description!!/$description/gi;
	$tmpl_links =~ s/!!url!!/$itemurl/gi;
	$tmpl_links =~ s/!!keywords!!/$listing_keywords/gi;
	
	
	### APPROVED OR NOT
	if (($row[15] ne "Y") and ($row[14] ne "Y"))
		{
		$tmpl_links =~ s/!!aproval_status!!/$regtext[2]/gi;
		}
		else
		{
		$tmpl_links =~ s/!!aproval_status!!/$regtext[1]/gi;
		}
	
	### COMMENTS
	
	$comlink = "$script_url/reviews.cgi?id=$row[0]&cid=$row[1]";
	$tmpl_links =~ s/!!cp_com!!/$comlink/gi;
	
	
	### MODIFY LINK
	$tmpl_links =~ s/!!cp_modify!!/$script_url\/modify2\.cgi\?cid=$row[1]&id=$row[0]/gi;
	
	### RATING
	#if ($rating eq "") {$rating = $gsettings->{norating};}

	if ($rating eq "") { $rating = "0.00"; }
	$tmpl_links =~ s/%%rating%%/$rating/gi;
	$tmpl_links =~ s/!!rating!!/$rating/gi;

	
	$rating_image = pseek::get_rating_images($rating); 
	$tmpl_links =~ s/!!rating_image!!/$rating_image/gi;
	
	### COMMENTS
	$nrc = "";
	if ($row[23] > 0) { $nrc = "($row[23])";}
	
	$comments = "<a href=\"$script_url/reviews.cgi?id=$row[0]&cid=$row[1]\" target=\"_blank\">$comments</a> $nrc";
	$tmpl_links =~ s/%%reviews%%/$comments/gi;
	$tmpl_links =~ s/!!reviews!!/$comments/gi;
	
	### MODIFY
	$modifyl = $gsettings->{modify_text};
	$modifyl = "<a href=\"$script_url/modify.cgi?id=$row[0]&cid=$row[1]\">$modifyl</a>";
	$tmpl_links =~ s/%%modify%%/$modifyl/gi;
	$tmpl_links =~ s/!!modify!!/$modifyl/gi;

	### HITS
	if ($hits eq "") { $hits = "0"; }
	if ($votes eq "") {$votes = "0";}	
	
	$tmpl_links =~ s/%%hits%%/$hits/gi;
	$tmpl_links =~ s/!!hits!!/$hits/gi;
	
	$tmpl_links =~ s/%%votes%%/$votes/gi;
	$tmpl_links =~ s/!!votes!!/$votes/gi;

	### DATE
	$date = pseek::decode_date($date);
	$tmpl_links =~ s/%%date%%/$date/gi;
	$tmpl_links =~ s/!!date!!/$date/gi;

	#### %%title_without_link%%
	if (($url ne "") and ($url ne "http://")) 
		{
		$title_with_link = "<a href=\"$url\" target=\"_blank\">$title_with_link</a>";
		}	
	
	$tmpl_links =~ s/%%title_with_link%%/$title_with_link/gi;
	$tmpl_links =~ s/!!title_with_link!!/$title_with_link/gi;
	
	
	$tmpl_links =~ s/%%title_without_link%%/$row[2]/gi;
	$tmpl_links =~ s/!!title_without_link!!/$row[2]/gi;

	### NEW IMAGE

		if	($row[17] ne "")
			{
			$today_time = time();
			
			$time1 = 86400 * $gsettings->{days1};
			$time2 = 86400 * $gsettings->{days2};
			$time3 = 86400 * $gsettings->{days3};
			
			if ($row[17] >= ($today_time - $time1))
				{ $critnew = "<img src=\"$web_url/new1.gif\">"; $current_tmplsearch =~ s/!!new!!/$critnew/g; }
				elsif ($row[17] >= ($today_time - $time2))
				{ $critnew = "<img src=\"$web_url/new2.gif\">"; $current_tmplsearch =~ s/!!new!!/$critnew/g; }
				elsif ($row[17] >= ($today_time - $time3))
				{ $critnew = "<img src=\"$web_url/new3.gif\">"; $current_tmplsearch =~ s/!!new!!/$critnew/g; }
			}
			$tmpl_links =~ s/!!new!!/$critnew/gi;


		### POP
			if ($row[12] > $gsettings->{pop_links_amount})
				{
				$critpop = "<img src=\"$web_url/pop.gif\">";
				$tmpl_links =~ s/!!pop!!/$critpop/gi;
				}
				else
				{
				$tmpl_links =~ s/!!pop!!//gi;
				}
	

	#### CATEGORY
		
			$cats = ""; $rdcat = ""; $ecat = ""; $lv = 0;
			for ($ms = $start_count; $ms < ($start_count + 16); $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . " / ";
					$rdcat = $rdcat . pseek::encode_dir($row[$ms]) . "/";
					$ecat = $ecat . pseek::encode_dir($row[$ms]) . "-";
					$lv++;
					}
				}
			chop($ecat);
			
	
			$cats = substr($cats, 0, length($cats) - 2);
			if ($gsettings->{dyn_stat} eq "Dynamic")
				{
				$from_category = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\" target=\"_blank\">$cats</a>";
				}
				else
				{
				$from_category = "<a href=\"$web_url/$rdcat\" target=\"_blank\">$cats</a>";
				}
	
			$tmpl_links =~ s/%%category%%/$from_category/g;
			$tmpl_links =~ s/!!category!!/$from_category/g;
	
	

	### !!link_image!!
	$the_link_image = "";
	if ($tmpl_links =~ /!!link_image!!/i) 
		{
		$img_fname = "$web_dir/imagefiles/" . $row[0] . "." . $row[6];

		$image_width = $gsettings->{image_width};
		$image_height = $gsettings->{image_height};

		if ($image_width > 0) { $imgw = qq[ width="$image_width" ]; }
		if ($image_height > 0) { $imgh = qq[ height="$image_height" ]; }

					
			if (-e "$img_fname")
				{
				$the_image_url = "$web_url/imagefiles/$row[0]" . "." . $row[6];
				$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
				$tmpl_links =~ s/!!link_image!!/$the_link_image/gi;
				}
				else
				{
				if ($gsettings->{default_image} =~ /http:/)
					{
					$the_image_url = $gsettings->{default_image};
					$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
					$tmpl_links =~ s/!!link_image!!/$the_link_image/gi;
					}
					else
					{
					$tmpl_links =~ s/!!link_image!!//gi;
					}

				}
		}


if ($tmpl_links =~ /!!link_file!!/i)
	{
	if (($row[6] eq "") and ($gsettings->{default_image} =~ /http:/))
		{
		$img_fname = $gsettings->{default_image};
		$tmpl_links =~ s/!!link_file!!/$img_fname/gi;
		}
		elsif ($row[6] ne "")
		{
		$img_fname = "$web_url/imagefiles/" . $row[0] . "." . $row[6];
		$tmpl_links =~ s/!!link_file!!/$img_fname/gi;
		}
		else
		{
		$tmpl_links =~ s/!!link_file!!//gi;
		}
	}
	
	
	#### 	MORE INFO
	
			#if ($gsettings->{dyn_stat} eq "Static")
			#	{
			#	$mfile = "$web_url/$ecats_stat" . $row[0] . $gsettings->{gen_file_ext};
			#	$tmpl_links =~ s/%%more_info_url%%/$mfile/gi;
			#	$tmpl_links =~ s/!!more_info_url!!/$mfile/gi;
			#	}
			#	else
			#	{
				$tmpl_links =~ s/%%more_info_url%%/$script_url\/linfo\.cgi?id=$row[0]&newpop=$dynstat/gi;
				$tmpl_links =~ s/!!more_info_url!!/$script_url\/linfo\.cgi?id=$row[0]&newpop=$dynstat/gi;
			#	}


	### EXTRA FIELDS/KEYS
	$rowcntr = 27;
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $nmbr, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $k_item);

		if ($nmbr eq "Upload")
				{
				 if ($row[$rowcntr] eq "") 
					 {
					 $tmpl_links =~ s/!!$keyname!!/$na/g;
					 }
					else
					 {
						$apreapp = ""; $aapend = "";
						foreach $upload_item (@upl_items)
							{
							($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t) = split (/:o:-:o:/, $upload_item);
							if ($keyname eq $fieldname_t) { $apreapp = $preappend_t; $aapend = $append_t; }
							}
								
						$upcrit = $apreapp . "$web_url/imagefiles/$row[0]/$keyname" . "." . $row[$rowcntr] . $aapend;
						$tmpl_links =~ s/!!$keyname!!/$upcrit/g;
					 } 
			
				 }
		elsif ($imgk eq "Yes")
			{
			if ($row[$rowcntr] ne ""){$imgcrit = "<img src=\"$row[$rowcntr]\" border=\"0\">";} else { $imgcrit = $na; }
			$tmpl_links =~ s/%%$keyname%%/$imgcrit/g;
			$tmpl_links =~ s/!!$keyname!!/$imgcrit/g;
			}
			else
			{
			if ($allow_html eq "N") { $row[$rowcntr] =~ s/</&lt;/g; $row[$rowcntr] =~ s/>/&gt;/g; }
			if ($carriage_pagebreak eq "Y") { $row[$rowcntr] =~ s/\n/<BR>/gi; }
			
			if ($row[$rowcntr] eq "") { $row[$rowcntr] = $na; }
			$tmpl_links =~ s/%%$keyname%%/$row[$rowcntr]/g;
			$tmpl_links =~ s/!!$keyname!!/$row[$rowcntr]/g;
			}
			$rowcntr++;
		}	



	####
	
	$all_links = $all_links . $tmpl_links;
	
	}

$sth->finish;
$dbh->disconnect;  

if ($rows > 0)
	{
	$cp_template =~ s/!!user_links!!/$all_links/gi;
	}
	else
	{
	$nolinks_crit = pseek::get_file_contents("$data_dir/rgs_nolinks.html");
	$cp_template =~ s/!!user_links!!/$nolinks_crit/gi;
	}

#########

$cp_template = pseek::ts_insert_template_includes($cp_template);
$cp_template = pseek::fill_vars($cp_template);
$cp_template = pseek::fill_cp_vars($cp_template);

print $cp_template;

}




################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

